#RequireAdmin
; JunctionBox
; Released by IWR Consultancy under the GPL licence, v3.
; Compile with 3.3.14.2
; This version, Nov 2015.

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Aut2exe=d:\autoit\3-3-14-2\aut2exe\aut2exe.exe
#AutoIt3Wrapper_Res_Comment=
#AutoIt3Wrapper_Res_Description=
#AutoIt3Wrapper_icon=junctionbox.ico
#AutoIt3Wrapper_outfile=JunctionBox.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_UseAnsi=y
#AutoIt3Wrapper_Res_Description=Windows 7/8 junction backup/repair tool. 
#AutoIt3Wrapper_Res_Fileversion=2.0
#AutoIt3Wrapper_Res_LegalCopyright=IWR Consultancy, GPL v3
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
opt("TrayAutoPause",0)
opt("TrayIconHide",1)

global $progname="Junction Box"
local $doProfile=""
global $doswindow=@SW_HIDE
global $appVersion="2.0"

if FileExists(@scriptdir & "\setacl.exe")=0 then
  local $msg= msgbox(52,"Missing Dependency","This utility requires setacl.exe to be present in its own folder. Without this, some functionality may not work correctly. You can download SetACL from http://setacl.sourceforge.net. Do you wish to continue without it?")
  if $msg<>6 then exit
endif

If not IsDeclared("profileContainer") then
 global $profileContainer=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList","ProfilesDirectory")
 global $systemDrive=EnvGet("SystemDrive")
 $profileContainer=stringreplace($profileContainer,"%systemdrive%",$systemDrive)
; msgbox(0,$profileContainer,$systemDrive)
endif

MainGUI()
; repairjunctions($doProfile)

func MainGUI()
#include <GUIConstants.au3>
;#include <StaticConstants.au3>
;#include <WindowsConstants.au3>

local $profileList="* All Profles and System Junctions *"
$profsrch = FileFindFirstFile($profileContainer & "\*.*")  
While $profsrch <> -1
    $thisProfile = FileFindNextFile($profsrch) 
    if @error Then ExitLoop
    if stringinstr(FileGetAttrib($profileContainer & "\" & $thisProfile),"D")=0 then continueloop
    if stringinstr(FileGetAttrib($profileContainer & "\" & $thisProfile),"S")>0 then continueloop
    if stringinstr($thisProfile,"Default User")>0 then continueloop
    if stringinstr($thisProfile,"All Users")>0 then continueloop
    $profileList=$profileList & "|" & $thisProfile
wend


$mainGUI = GUICreate($progname, 590, 241, 194, 117)
$inpDoProfile = GuiCtrlCreateCombo($doProfile, 56, 104, 337, 21)
 guictrlsetdata($inpDoProfile,$profileList,"")
;$inpDoProfile = GUICtrlCreateInput($doProfile, 56, 104, 337, 21)
;$btnBrowse = GUICtrlCreateButton("Browse", 424, 104, 97, 25, 0)
$btnBackup = GUICtrlCreateButton("Backup Junctions", 56, 160, 169, 33, 0)
GUICtrlSetTip($btnBackup,"Backup junctions for all profiles")
$btnRestore = GUICtrlCreateButton("Restore Junctions", 376, 160, 145, 33, 0)
GUICtrlSetTip($btnRestore,"Restore junctions to the selected profile")
$btnQuit = GUICtrlCreateButton("Quit", 264, 160, 75, 33, 0)
$imgJBLogo=GUICtrlCreateIcon(@ScriptFullPath,-1,26,25)
$Label1 = GUICtrlCreateLabel("Junction Box", 76, 24, 249, 40)
GUICtrlSetFont(-1, 24, 800, 2, "Arial")
$Label2 = GUICtrlCreateLabel("NTFS Junction Manager", 344, 32, 120, 17)
$Label3 = GUICtrlCreateLabel("Profile Folder:", 56, 80, 73, 17)
$Label4 = GUICtrlCreateLabel("By IWR Consultancy", 400, 56, 102, 17)

$mnuFile = GUICtrlCreateMenu("&File")
$mnuJunctions = GUICtrlCreateMenu("&Junctions")
$mnuHelp = GUICtrlCreateMenu("&Help")
$mnuBackup=GUICtrlCreateMenuItem("Backup complete set of Junctions to a catalog file", $mnuJunctions)
$mnuRestore=GUICtrlCreateMenuItem("Restore junctions to the selected profile", $mnuJunctions)
$mnuDelete=GUICtrlCreateMenuItem("Delete all standard Junctions in the selected Profile", $mnuJunctions)
$mnuExit = GUICtrlCreateMenuItem("Exit", $mnuFile)
$mnuWebsite=GuiCtrlCreateMenuItem("Visit our &Website",$mnuHelp)
$mnuAbout = GUICtrlCreateMenuItem("About", $mnuHelp)

GUISetState(@SW_SHOW)


While 1
$msgGUI = GUIGetMsg()
Switch $msgGUI
case $GUI_EVENT_CLOSE
 Exit
case $btnQuit
 Exit
case $mnuExit
 Exit
case $btnBackup
 $doProfile=GuiCtrlRead($inpDoProfile)
 if stringleft($doProfile,1)="*" then $doProfile="*"
 CatalogJunctions("")
case $btnRestore
 $doProfile=GuiCtrlRead($inpDoProfile)
 if stringleft($doProfile,1)="*" then $doProfile="*"
 RepairJunctions($doProfile)
case $mnuRestore
 $doProfile=GuiCtrlRead($inpDoProfile)
 if stringleft($doProfile,1)="*" then $doProfile="*"
 RepairJunctions($doProfile)
case $mnuBackup
 $doProfile=GuiCtrlRead($inpDoProfile)
 if stringleft($doProfile,1)="*" then $doProfile="*"
 CatalogJunctions("")
case $mnuDelete
 $doProfile=GuiCtrlRead($inpDoProfile)
 if stringleft($doProfile,1)="*" then $doProfile="*"
 RepairJunctions($doProfile,"delete")
case $mnuWebsite
  ShellExecute('http://iwrconsultancy.co.uk') 
case $Label1
  ShellExecute('http://iwrconsultancy.co.uk/junctionbox') 
case $mnuAbout
 msgbox(64, $progname, "NTFS Junction Archiving Utility, version " & $appVersion & ", by IWR Consultancy.")
EndSwitch
WEnd

endfunc


func repairjunctions($_doProfile, $_action="repair")

; Purpose: scans a specified userprofile OR whole system disk and restores or deletes
; the standard (or backed-up) set of junctions in that structure.

if $_doProfile="" then 
 msgbox(48,"No profile specified","Please specify a profile to repair the junctions within, or * for all including the system folders")
 return 0
endif
 
If not IsDeclared("profileContainer") then
 global $profileContainer=RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\ProfileList","ProfilesDirectory")
 global $systemDrive=EnvGet("SystemDrive")
 $profileContainer=stringreplace($profileContainer,"%systemdrive%",$systemDrive)
; msgbox(0,$profileContainer,$systemDrive)
endif

$WorkingDir=@WorkingDir

$junctionfile=@scriptdir & "\DefaultJunctions.ntj"
if @osversion="WIN_10" then $junctionfile=@scriptdir & "\Win10DefaultJunctions.ntj"
if $_action="delete" then
 $newJunctionfile=FileOpenDialog ( "Select catalog of junctions to Delete", @WorkingDir, "Junction Backups (*.ntj)|All Files (*.*)" ,3, "DefaultJunctions.ntj")
else
 $newJunctionfile=FileOpenDialog ( "Select catalog to Restore from", @WorkingDir, "Junction Backups (*.ntj)|All Files (*.*)" ,3, "DefaultJunctions.ntj")
endif
if @error then return 0
FileChangeDir($WorkingDir)
if  $newJunctionfile<>"" then  $junctionfile=$newJunctionfile
local $systemForceCreation=IniRead($junctionfile,"General","SystemForceCreation",0)
local $userForceCreation=IniRead($junctionfile,"General","UserForceCreation",1)
local $allowMissingTarget=IniRead($junctionfile,"General","AllowMissingTarget",0)
global $DefaultIsDefault=IniRead($junctionfile,"General","DefaultIsDefault",0)
local $OSLanguages=IniRead($junctionfile,"General","OSLanguages","-")
local $OSVersions=IniRead($junctionfile,"General","OSVersions","-")
if stringinstr($OSVersions,@OSVersion)=0 then
  msgbox(48,"Possible Compatibility Issue","This junction backup file does not appear to be suitable for your operating system. Note in particular that there is NO requirement for junction-repair on Windows XP, and that whilst Windows 7 and 8 can use the same backups, Windows 10 requires a different structure." & @LF & @LF & " As proceeding could lead to damage, execution has been halted." & @LF & @LF & "If you are sure that the contents of the backup match the folder-names in your OS, and that your OS requires userprofile-junctions, then add " & @OSVersion & " to the OSVersions value in the backup file, and proceed.")
 exit
endif

if stringinstr($OSLanguages,@OSLang)=0 then
  msgbox(48,"Possible Compatibility Issue","The backup file file you are using was not specifically designed for the language this operating system is configured to use. " & @LF & @LF & " As proceeding could lead to damage, execution has been halted." & @LF & @LF & "If you are sure that the contents of the backup file match the folder-names in your OS, then add " & @OSLang & " to the OSLanguages value in the backup file, and proceed.")
 exit
endif

$inisections = IniReadSectionNames($junctionfile)
if @error then 
 msgbox(48,"Error","Unable to open backup file for reading. This may be because it is being held-open by another application.") 
 return 0
endif
if $_action="delete" then 
  ProgressOn ( "Deleting System Junctions", "Scanning " , "", -1,-1,16)
else
  ProgressOn ( "Restoring System Junctions", "Scanning " , "", -1,-1,16)
endif

if $_doProfile="*" then 
 ; Do the standard non-user locations:
 for $ct=1 to $inisections[0]
   $thisProfile=$inisections[$ct]
   ; msgbox(0,"Processing profile",$thisprofile,1)
   if $thisProfile="Default User" then continueloop ; Default user is a fake profile!
   if FileExists(pathtrans("@",$thisProfile))=0 then continueloop
   if $inisections[$ct]="General" then continueloop
   $thesejunctions = IniReadSection ( $junctionfile, $thisProfile )
   if @error then continueloop
   for $cct=1 to $thesejunctions[0][0]
     local $jtype="J"
     $thisJunction=$thesejunctions[$cct][0]
     $thisTarget=$thesejunctions[$cct][1]
     if stringmid($thisTarget,2,1)='=' then 
       ; Get link type if present, and remove from target string.
       $jtype=stringmid($thisTarget,1,1)
       $thisTarget=stringmid($thisTarget,3)
     endif
     $thisJunction=PathTrans($thisProfile,$thisJunction)
     $thisTarget=PathTrans($thisProfile,$thisTarget)

     ProgressSet(($ct/$inisections[0])*100,"Junction: " & $thisJunction,"Scanning: " & $thisProfile)
     if $_action="delete" then
       DeleteJunction($thisJunction)
     else 
       ; mod to accommodate Win8/81 missing favourites..
       if (FileExists($thisTarget)) OR ($allowMissingTarget=1) then 
         CreateJunction($thisJunction,$thisTarget,$systemForceCreation,1,$jtype)
       endif
     endif
     ; SetPermissions($thisJunction,1) -now called by createjunction, neater.
   next
 next
endif

ProgressOff()

; Do individual profiles: 

if $_action="delete" then 
  ProgressOn ( "Deleting User Junctions", "Scanning " , "", -1,-1,16)
else
  ProgressOn ( "Restoring User Junctions", "Scanning " , "", -1,-1,16)
endif

$profsrch = FileFindFirstFile($profileContainer & "\*.*")  
While $profsrch <> -1
    local $usingDefault=false
    $thisProfile = FileFindNextFile($profsrch) 
    if @error Then ExitLoop
    if stringinstr(FileGetAttrib($profileContainer & "\" & $thisProfile),"D")=0 then continueloop
    if $thisProfile="Default User" then continueloop
    if ($_doProfile = "*") then 
      for $ct=1 to $inisections[0]
        ;skip system-created profiles
        if $thisProfile=$inisections[$ct] then continueloop 2
      next
      $thesejunctions = IniReadSection ($junctionfile, "Default" )
      $usingDefault=true
      if @error then continueloop
    else
     ; msgbox(0,"Profilematch",$thisProfile & @lf & $_doProfile,3)
      if ($thisProfile <> $_doProfile) then continueloop
      ; Method not ideal for single profile/default repair. ************
      $thesejunctions = IniReadSection ($junctionfile, $thisProfile )
      if @error then 
        $thesejunctions = IniReadSection ($junctionfile, "Default" )
        $usingDefault=true
      endif  
      if @error then continueloop
    endif
    ; Process junctions in this profile: 
;    $thesejunctions = IniReadSection ($junctionfile, "Default" )
    if @error then continueloop
    for $ct=1 to $thesejunctions[0][0]
      if (@OSVersion="Win_10") AND ($usingDefault=true)AND ($DefaultIsDefault=0) then 
        if StringInStr($thesejunctions[$ct][1],"INetCache")=0 then 
          ; Only process two junctions for Windows 10 users
          continueloop
        endif
      endif
      
      $thisJunction=pathtrans($thisprofile,$thesejunctions[$ct][0])
      $thisTarget=PathTrans($thisProfile,$thesejunctions[$ct][1])
      ProgressSet(($ct/$thesejunctions[0][0])*100,"Junction: " & $thisJunction,"Processing: " & $thisProfile)
     if $_action="delete" then
       DeleteJunction($thisJunction)
     else 
       CreateJunction($thisJunction,$thisTarget,$userForceCreation,1)
     endif
      ; SetPermissions($thisJunction,1)
    next
Wend

; Close the search handle
FileClose($profsrch)
ProgressOff()

endfunc

func catalogjunctions($_backupfile="", $_basedir="")

$t1=@tempdir & "\JunctionBackup.txt"
FileDelete($t1)
if FileExists($t1) then
 msgbox(16,"Error","Unable to delete temporary work-file. If two copies of this program are running, please close the other") 
 return 0
endif 

if $_backupfile="" then 
 $_backupfile=FileSaveDialog ( "Select a name for your backup-file", @scriptdir, "Junction Backups (*.ntj)|All (*.*)" , 18 , "JunctionBackup.ntj")
 if @error>0 or $_backupfile="" then return 0
endif

if stringinstr($_backupfile,"DefaultJunctions.ntj")>0 then
msgbox(48,"Operation Not Permitted","You should not overwrite the default config-file with a user backup. Please choose another filename")
return 0
endif

if FileExists($_backupfile) then 
 FileDelete($_backupfile)
 if @error then msgbox(48,"Error","Unable to delete previous backup. Please check whether another program is holding this file open for writing.")
endif

local $count=0

if stringinstr($_basedir,"*")>0 or stringinstr($_basedir,"?")>0 then
 msgbox(16,@scriptname & " - error in input","Wildcards not permitted, this utility acts on a specified disk or folder") 
 return 0
endif

global $progress=0
ProgressOn ( "Processing Junction Backup", "Scanning disk structure.." , "May take a few minutes depending on disk size." , -1 , -1 , 16 )
AdlibRegister ( "Progressbar" , 500 )

if $_basedir="" then $_basedir=$systemDrive & "\"
$runstr='cmd /c dir "' & $_basedir & '" /al /s > "' & $t1 & '"'

$absdir=$_basedir

RunWait($runstr,@scriptdir,@sw_minimize)

$progress=1
ProgressSet($progress,"","Writing data to backup")

iniWrite($_backupfile,"General","OSLanguages",@OSLang)
iniWrite($_backupfile,"General","OSVersions",@OSVersion)

$hd1=FileOpen($t1,0)

while 1
 local $jtype="";
 $aline=FileReadLine($hd1)
 if @error then exitloop
select
case stringinstr($aline,"Directory of")
 $jpos=stringinstr($aline,"of")
 $absdir=stringmid($aline,$jpos+3,255) 
; if stringright($absdir,1)<>"\" then $absdir=$absdir & "\"
case stringinstr($absdir,"$Recycle")>0 
case stringinstr($aline,"JUNCTION") OR stringinstr($aline,"SYMLINKD")
 $jtype='J'
 $jpos=stringinstr($aline,"JUNCTION")
 if $jpos=0 then 
  $jpos=stringinstr($aline,"SYMLINKD")
  if $jpos >0 then $jtype='D'
 endif
 if $jpos=0 then 
  $jpos=stringinstr($aline,"SYMLINK")
  if $jpos >0 then $jtype='F'
 endif
 $aline=stringmid($aline,$jpos+9)
 $aline=stringstripws($aline,3)
 $alinex=stringsplit($aline,"[")
 $alinex[0]=StringStripWS($alinex[0],1) ; allow for file link, shorter descriptor.
 if $alinex[0]<2 then continueloop
 $alinex[2] = stringtrimright($alinex[2],1)
 $absTarget=$alinex[2]
; msgbox(0,"absdir", $absdir,1)

 ; Get section and junction prefix:
 $jSubdir=""
 $absPSection=$absdir
 $pSec=stringsplit($absPSection,"\")
 $parts=$pSec[0]
 $pSection=$absPSection

; Encode  section name and junction target: 

 select
 case ($parts=2) AND (stringinstr($pSec[1] & "\" & $pSec[2],$profileContainer)=1)
  $pSection="@"
; case ($parts=1) AND ($pSec[1]=$systemDrive) 
;  $pSection="\"
 case ($parts=3) AND (stringinstr($pSec[1] & "\" &  $pSec[2], $profileContainer)=1)
  $pSection= $pSec[3]
 case ($parts>3) AND (stringinstr($pSec[1] & "\" &  $pSec[2], $profileContainer)=1)
  $pSection= "" & $pSec[3]
  for $dct=4 to $parts
     $jSubdir=$jSubdir & $pSec[$dct] & "\"
  next
 $absPSection= $pSec[1] & "\" & $pSec[2] & "\" & $pSec[3]
 case else
   if ($pSec[1]=$systemDrive) then 
     $pSection=StringReplace($absPSection,$systemDrive,"",0,1)
   endif
 endselect
 
;junction location is always rel to section folder, so no need to encode.
 $thisJunction=$jSubdir & $alinex[1] 
 
; Target is relative to section header if possible, and has standard folders encoded.
select
 case stringinstr($absTarget,$absPSection & "\")=1
  $jTarget= stringtrimleft($absTarget,stringlen($absPSection & "\"))
 case stringinstr($absTarget,$profileContainer & "\")=1
  $jTarget= stringreplace($absTarget,$profileContainer & "\","@\", 0,1)
 case stringinstr($absTarget,$profileContainer)=1
  $jTarget= stringreplace($absTarget,$profileContainer,"@", 0,1)
 case stringinstr($absTarget,$systemDrive)=1
  $jTarget= stringtrimleft($absTarget,stringlen($systemDrive))
 case else
  ; Allow for situation where junction with nonexistent target drive exists.. 
  ; added Oct 15.  
  $jTarget=$absTarget
endselect 
 
; ##################################################
 if $jtype <>'J' then 
   $typePrefix=$jtype & '='
 else
   $typePrefix=""
 endif
 iniwrite($_backupfile,$pSection,$thisJunction,$typePrefix&$jTarget)
 $count=$count+1
endselect
wend

ProgressSet(100,"Backup written","Process complete")
sleep(500)

FileClose($hd1)
FileDelete($t1)

AdLibUnregister("Progressbar")
ProgressOff()

if $count>0 then
 msgbox(64,$progname,$count & " Junctions Archived into " & $_backupfile)
else
 msgbox(64,$progname,"Nothing to do, no Junctions found in specified path.")
endif

FileDelete($t1)

endfunc

func CreateJunction($location, $target, $forceCreation=0, $lockdown=0, $thisType='J')

; Purpose: Like it says on the tin.
; $thisType is J, S or H. Permissions are only set on J. 
; Action:
; If force=1, created directory structure if it doesnt exist.
; If force>1, also removes any bad juctions or same-named files that are in the way.
; If lockdown set, applies Everyone>DenyListContents permission to prevent browsing into junction.
; (or so Microsoft would hope, only it's not always effective as some backup apps can bypass permissions.)

if not IsDeclared("doswindow") then local $doswindow=@SW_HIDE
$locPath=stringleft($location,stringinstr($location,"\",0,-1)-1)

if $ForceCreation>0 then
 if not FileExists($locpath) then DirCreate($locPath)
endif

if StringInStr("J,H,F,D", $thisType)=0 then return 0

if $ForceCreation>1 then DeleteJunction($location)

if $thisType<>'F' then 
  $thisTypeAttr='/' & $thisType
else
  $thisTypeAttr=""
endif

$runstr='cmd /c mklink '& $thisTypeAttr &' "'& $location & '" "' & $target & '"'
$rtn=RunWait($runstr,@ScriptDir,$doswindow)
; msgbox(0,"Creating Junction",$location & " > " & $target & " " & $rtn,1)

if ($lockdown>0) AND ($thisType='J') then SetPermissions($location,1)

endfunc

func SetPermissions($location, $action=1)
;Purpose: Sets permissions so that Explorer cannot browse into the junction,(ostensibly) to prevent cyclic loops.

if not IsDeclared("doswindow") then local $doswindow=@SW_HIDE

if $action>0 then
 $runstr = 'setacl -ot file -on "' & $location & '" -ownr "n:' & "SYSTEM" & ';s:n"  -actn setowner'
 $rtn1 = RunWait($Runstr,@scriptdir,$doswindow)
 $runstr = 'setacl -ot file -on "' & $location & '" -ace "n:' & "Everyone" & ';s:n;m:deny;i:np;p:list_dir"  -actn ace'
 $rtn2 = RunWait($Runstr,@scriptdir,$doswindow)
 FileSetAttrib($location,"+SH-A")
else
 $runstr = 'setacl -ot file -on "' & $location & '" -ownr "n:' & @UserName & ';s:n"  -actn setowner'
 $rtn1 = RunWait($Runstr,@scriptdir,$doswindow)
 $runstr = 'setacl -ot file -on "' & $location & '" -ace "n:' & "Everyone" & ';s:n;m:deny;i:np;p:list_dir"  -actn clear'
 $rtn2 = RunWait($Runstr,@scriptdir,$doswindow)
 FileSetAttrib($location,"-SH")
endif

endfunc

func DeleteJunction($location)
 if FileExists($location) then
   SetPermissions($location,0)
   FileSetAttrib($location,"-RHSA")
   if stringinstr(FileGetAttrib($location),"D") then 
     DirRemove($location)
   else
     FileDelete($location)
   endif
 endif
endfunc

func PathTrans($basePath,$inPath)

; Purpose: Enables use of macros for systemroot and profilecontainer paths, 
; so that routine is not tied-to default locations for these items.
; \ denotes sytemroot path
; @ denotes path relative to profile container
; others are relative to current profile folder ($basepath)
; Requires globals $systemDrive and $profileContainer (Auto-created)

 
select
  case stringleft($basepath,1)="\"
   $basepath = $systemdrive & $basepath
  case stringleft($basepath,1)="@"
   $basepath = stringreplace($basepath,"@",$profilecontainer,1)
  case $basepath = ""
   $basepath = $profileContainer
  case else
   $basepath = $profileContainer & "\" & $basepath
endselect

if stringright($basePath,1) <> "\" then $basePath=$basePath & "\"

select
  case stringleft($inPath,1)="\"
   $outPath = $systemdrive & $inPath
  case stringleft($inPath,1)="@"
   $outPath = stringreplace($inPath,"@",$profilecontainer,1)
  case else
   $outPath = $basepath & $inPath
endselect

if stringinstr($outPath,"\\") > 0 then 
 $outPath=stringreplace($outPath,"\\", "\")
endif

; msgbox(0,"3", $basepath & @lf & $inpath & @lf & $outpath)

return $outPath
endfunc

func Progressbar()
if not IsDeclared("progress") then 
 AdLibUnregister("Progressbar")
 return
endif

$progress=$progress + 2

If $progress>100 then $progress=1

ProgressSet($progress)

endfunc